<template>
  <SwPluginSlot name="gs-navigation"
                class="sw-gs-navigation sw-gs-nav-overlay"
                :class="[navPositionClass, listOpenClass]">
    <SwPluginSlot name="gs-navigation-actions" class="sw-gs-navigation-actions">

      <SwGsBackButton/>

      <SwGsConnectionIndicator/>

      <div class="sw-gs-actions-wrapper" v-if="!isSelfService">
        <SwGsGuideActions v-if="isGuide"/>
        <SwGsClientActions v-if="isClient"/>
      </div>

      <div v-if="isGuide || isSelfService" class="sw-gs-pagination-wrapper">
        <SwGsPagination></SwGsPagination>
      </div>

      <SwButton v-if="(isGuide || isSelfService) && navigation"
                class="sw-gs-navigation-list-toggle-btn color-transparent is-circle"
                :title="$t('Toggle page navigation')"
                @click="togglePageList(!isPageListOpen)">
        <SwGsIconBars class="color-dark-secondary size-sm"/>
      </SwButton>
    </SwPluginSlot>

    <SwPluginSlot name="gs-navigation-content" class="sw-gs-navigation-content">
      <SwGsNavigationList/>
    </SwPluginSlot>
  </SwPluginSlot>
</template>

<script lang="ts">
  import SwPluginSlot from "sw-plugins/SwPluginSlot.vue"
  import SwButton from "@/components/atoms/SwButton.vue";
  import SwGsClientActions from "./SwGsClientActions.vue"
  import SwGsGuideActions from "./SwGsGuideActions.vue"
  import SwGsPagination from "./SwGsPagination.vue";
  import SwGsBackButton from "./SwGsBackButton.vue";
  import SwGsNavigationList from "./SwGsNavigationList.vue";
  import SwGsConnectionIndicator from "../SwGsConnectionIndicator.vue";
  import { useAppointment } from "../../logic/composables/useAppointment";
  import { usePresentation } from "../../logic/composables/usePresentation";
  import { usePresentationLayer } from "../../logic/composables/usePresentationLayer";
  import { computed } from "@vue/composition-api";
  import { SwGsIconLongArrowLeft, SwGsIconBars } from "../icons";
  import { useUIState } from "@shopware-pwa/composables";

  export default {
    name: "SwGsNavigation",
    components: {
      SwPluginSlot,
      SwButton,
      SwGsClientActions,
      SwGsGuideActions,
      SwGsPagination,
      SwGsIconLongArrowLeft,
      SwGsIconBars,
      SwGsBackButton,
      SwGsNavigationList,
      SwGsConnectionIndicator
    },

    setup() {
      const { isGuide, isClient, isSelfService } = useAppointment();
      const { navPositionClass } = usePresentationLayer();
      const { treeNavigation } = usePresentation();
      const { isOpen: isPageListOpen, switchState: togglePageList } = useUIState({ stateName: "GS_NAVIGATION_PAGE_LIST_STATE" });

      const listOpenClass = computed(
          () => (isPageListOpen.value ? 'list-opened' : 'list-closed')
      );

      return {
        isGuide,
        isClient,
        isSelfService,
        navPositionClass,
        navigation: treeNavigation,
        togglePageList,
        isPageListOpen,
        listOpenClass,
      }
    }
  }
</script>

<style lang="scss" scoped>
  @import "@/assets/scss/variables";

  .sw-gs-navigation {
    position: absolute;
    display: flex;
    flex-direction: column;
    z-index: var(--navigation-z-index);
    top: var(--spacer-sm);
    right: 0;
    margin-right: var(--spacer-base);

    &.list-opened {
      z-index: calc(var(--modal-container-z-index) + 1); // dropdown needs to lay over the modal
    }

    &.layer-minimized {
      right: var(--presentation-layer-width-minimized);
      transition: right 0.3s ease-in-out;
    }

    @include for-tablet {
      &.layer-maximized {
        right: var(--presentation-layer-width-maximized);
        transition: right 0.3s ease-in-out;
      }
    }
  }

  .sw-gs-navigation-actions {
    display: flex;
  }

  .sw-gs-navigation-list-toggle-btn {
    margin-left: auto;
  }
</style>
